//Copyright 2005 Aaron Cooper
/*
This file is part of JGrail.
JGrail is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

JGrail is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with JGrail; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA 
*/

import javax.swing.*;
import javax.swing.event.*;

import java.awt.*; 
import java.awt.event.*;

import java.io.*;
import java.util.*;

/** 
* Shows information about JGrail (e.g. author, creation date).
* 
* @author Aaron Cooper
* @version 1.0 June 2004
*/ 

class HelpAboutDialog extends JDialog {
	/** Default width for the dialog window */ 
  protected static final int    DFLT_DIALOG_WIDTH  = 500;
	/** Default height for the dialog window */
  protected static final int    DFLT_DIALOG_HEIGHT = 400;
	/** Title for the dialog window */ 
  protected static final String DIALOG_TITLE     = "About JGrail";

  private JLabel titleLabel;
  private JLabel writtenLabel;
  private JLabel authorLabel;
  private JLabel dateLabel;
  private JLabel gplLabel;
  private String gplText;
	
	/** 
	* Creates a dialog window with the given argument as the parent frame 
	* 
	* @param owner the parent/owner for this dialog 
	*/ 
	public HelpAboutDialog(JFrame owner) {
    super(owner, DIALOG_TITLE, true);

    setSize(DFLT_DIALOG_WIDTH, DFLT_DIALOG_HEIGHT); 

    getContentPane().setLayout(new BorderLayout() ); 
   
    createComponents();
    setupComponents();
    addComponents();
	}

 /**
  * Creates the GUI widgets for this Dialog Window
  */ 
  protected void createComponents() {
    gplText      = "<html><br><br>JGrail is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.<br><br> JGrail is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. <br><br> See the GNU General Public License for more details.You should have received a copy of the GNU General Public License along with JGrail; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA</html>"; 
    titleLabel   = new JLabel("JGrail 1.3");
    writtenLabel = new JLabel("Copyright");
    authorLabel  = new JLabel("Cezar Campeanu");
    dateLabel    = new JLabel("version 1.3, February 2007");
    gplLabel     = new JLabel(gplText); 
  }

	
  /** 
  * Assigns values to properties of the GUI widgets contained in this Dialog Window
  */  	
  protected void setupComponents() {
    titleLabel.setAlignmentX(CENTER_ALIGNMENT);
    writtenLabel.setAlignmentX(CENTER_ALIGNMENT);
    authorLabel.setAlignmentX(CENTER_ALIGNMENT);
    dateLabel.setAlignmentX(CENTER_ALIGNMENT);
    gplLabel.setAlignmentX(CENTER_ALIGNMENT);
  }

	
  /** 
  * Adds the GUI widgets to this Dialog Window 
  */  	
  protected void addComponents() {
    JPanel mainPanel = new JPanel();
    mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.PAGE_AXIS) );
    mainPanel.setBorder(BorderFactory.createLineBorder(Color.BLUE) );

    mainPanel.add(Box.createRigidArea(new Dimension(0, 30) ));
    mainPanel.add(titleLabel);
    mainPanel.add(Box.createRigidArea(new Dimension(0, 10) ));

    mainPanel.add(writtenLabel);
    mainPanel.add(authorLabel);
    mainPanel.add(Box.createRigidArea(new Dimension(0, 10) ));
    mainPanel.add(dateLabel);
    mainPanel.add(gplLabel);

      //getContentPane().add(mainPanel, BorderLayout.CENTER);
    setContentPane(mainPanel);
  }

	
  /** 
  * Main function to test out functionality for this component.
  * 
  * @param args the array of arguments, provided by Java.
  */  
  public static void main(String[] args) throws Exception {
    HelpAboutDialog dlg = new HelpAboutDialog(null); 

    dlg.show();
  }
}
