//Copyright 2005 Aaron Cooper
/*
This file is part of JGrail.
JGrail is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

JGrail is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with JGrail; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA 
*/

import javax.swing.JPanel;
import java.awt.Color; 

/**
 * 
 * <p>
 * 
 * @author Aaron Cooper
 * @version 1.0 14-May-2005 
 * 
 * Most JGrail GUI panels inherit from this class.  Forces each class to setup their GUI elements via the 
 * three methods below.
 */
abstract class AbstractPanel extends JPanel {
  protected abstract void createComponents();
  protected abstract void setupComponents();  
  protected abstract void addComponents();
	
  	// make all the panels have a peach background
	public Color getBackground() { 
		return Global.PEACH; 
	}
}
