//Copyright 2005 Aaron Cooper
/*
This file is part of JGrail.
JGrail is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

JGrail is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with JGrail; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA 
*/

/**
 * 
 * <p>
 * 
 * @author Aaron Cooper
 * @version 1.0 11-Aug-2005
 * 
 * A separate thread is created to execute the fmtoview and xfig commands.  That way, the user can still use 
 * JGrail and look at the xfig/fmtoview windows at the same time.
 */
public class ExecProgThread extends Thread {

	private boolean done; 

	private String[] args;
	private Process proc;

	public ExecProgThread(String[] args) {
		this.args = args;
		done = false;
	}
	
	public void destroy() {
		proc.destroy();
	}
	
	public void setDone(boolean val) {
			System.out.println("setDone...");
		this.done = val;
	}

	public void run() {
		// run the command
		Runtime rt   = Runtime.getRuntime();
		
		try {
			proc = rt.exec(args);
				//proc.waitFor();
			while (!done) {
				;
			}
			
				System.out.println("run()... about to destroy");
			proc.destroy();
		}
		
		catch (Exception e) {
			Global.showBugErrorDialog(e);
		}
	}
}
