/*Author: Max Ahlquist
 * 
 * makeDefaultConfigFile.java creates the default config file(config.conf) in /home/user/.jgrail/ when the
 * config file can't be found. Typicaly on the first run of the program.
 * 
 */



import java.io.*;

public class makeDefaultConfigFile 
{
	public makeDefaultConfigFile()
	{
	}
	public void createConfig() throws IOException
	{
	

//declare the file name and the directory.   /home/user/.jgrail/.jgrail.conf
	File file = new File(""+System.getProperty("user.home")+ "/.jgrail/"+"jgrail.conf");
	BufferedWriter output = new BufferedWriter(new FileWriter(file));
	
	// output the file
	try
	{
		output.write("***Directories***");output.newLine();
		output.write("EXEC_PATH=/usr/local/grail/bin");output.newLine();
		output.write("SAVE_PATH=");output.newLine();
		output.newLine();
		output.write("***Unary Functions***");output.newLine();
		output.write("name=fltofm");output.newLine();
		output.write("desc=finite language to finite machine");output.newLine();
		output.newLine();
		output.write("name=fltore");output.newLine();
		output.write("desc=convert a finite language to a regular expression");output.newLine();
		output.newLine();
		output.write("name=fmtofl");output.newLine();
		output.write("desc=convert a finite-state machine to a finite language");output.newLine();
		output.newLine();
		output.write("name=fmtore");output.newLine();
		output.write("desc=convert a finite-state machine to a regular expression");output.newLine();
		output.newLine();
		output.write("name=fmtofcm");output.newLine();
		output.write("desc=convert a deterministic finite machine into a cover finite automaton");output.newLine();
		output.newLine();
		output.write("name=retofl");output.newLine();
		output.write("desc=convert regular expression to finite language");output.newLine();
		output.newLine();
		output.write("name=retofm");output.newLine();
		output.write("desc=convert regular expression to finite-state machine");output.newLine();
		output.newLine();
		output.write("name=iscomp");output.newLine();
		output.write("desc=test for completeness of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=isdeterm");output.newLine();
		output.write("desc=test for determinism of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=isuniv");output.newLine();
		output.write("desc=test for universality of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=isempty");output.newLine();
		output.write("desc=test regular expression for equivalence to empty set");output.newLine();
		output.newLine();
		output.write("name=isnull");output.newLine();
		output.write("desc=test regular expression for equivalence to empty string");output.newLine();
		output.newLine();
		output.write("name=fmmin");output.newLine();
		output.write("desc=minimize a machine by Hopcroft's algorithm");output.newLine();
		output.newLine();
		output.write("name=fmminrev");output.newLine();
		output.write("desc=minimize a machine by Brzozowski's algorithm");output.newLine();
		output.newLine();
		output.write("name=fmplus");output.newLine();
		output.write("desc=compute the "+" of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmreach");output.newLine();
		output.write("desc=compute the reachable submachine of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=flrevers");output.newLine();
		output.write("desc=reverse a finite language");output.newLine();
		output.newLine();
		output.write("name=fmrevers");output.newLine();
		output.write("desc=reverse a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmcment");output.newLine();
		output.write("desc=complement a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmcomp");output.newLine();
		output.write("desc=complete a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmdeterm");output.newLine();
		output.write("desc=make a finite-state machine deterministic");output.newLine();
		output.newLine();
		output.write("name=fmenum");output.newLine();
		output.write("desc=enumerate the language of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmrenum");output.newLine();
		output.write("desc=canonical numbering of a deterministic finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmstar");output.newLine();
		output.write("desc=Kleene star of a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=fmstats");output.newLine();
		output.write("desc=statistics about a finite-state machine");output.newLine();
		output.newLine();
		output.write("name=remin");output.newLine();
		output.write("desc=minimal bracketing of a regular expression");output.newLine();
		output.newLine();
		output.write("name=restar");output.newLine();
		output.write("desc=Kleene star of a regular expression");output.newLine();
		output.newLine();
		output.write("***Binary Functions***");output.newLine();
		output.write("name=flappend");output.newLine();
		output.write("desc=append two finite languages");output.newLine();
		output.write("opt=$STRING");output.newLine();
		output.newLine();
		output.write("name=flfilter");output.newLine();
		output.write("desc=intersect a finite language with a finite-state machine");output.newLine();
		output.write("opt=$STRING");output.newLine();
		output.newLine();
		output.write("name=fllq");output.newLine();
		output.write("desc=left quotient");output.newLine();
		output.newLine();
		output.write("name=flrq");output.newLine();
		output.write("desc=right quotient");output.newLine();
		output.write("opt=$STRING");output.newLine();
		output.newLine();
		output.write("name=flprepen");output.newLine();
		output.write("desc=prepend a finite language with a string");output.newLine();
		output.write("opt=$STRING");output.newLine();
		output.newLine();
		output.write("name=flprod");output.newLine();
		output.write("desc=product of two finite languages");output.newLine();
		output.newLine();
		output.write("name=fmcross");output.newLine();
		output.write("desc=cross product of two finite-state machines");output.newLine();
		output.newLine();
		output.write("name=flunion");output.newLine();
		output.write("desc=union of two finite languages");output.newLine();
		output.newLine();
		output.write("name=fmunion");output.newLine();
		output.write("desc=union of two finite-state machines");output.newLine();
		output.newLine();
		output.write("name=reunion");output.newLine();
		output.write("desc=union of two regular expressions");output.newLine();
		output.newLine();
		output.write("name=fmcat");output.newLine();
		output.write("desc=catenate two machines");output.newLine();
		output.newLine();
		output.write("name=recat");output.newLine();
		output.write("desc=catenate two regular expressions");output.newLine();
		output.newLine();
		output.write("name=fmexec");output.newLine();
		output.write("desc=test a word for membership in the language of a finite-state machine");output.newLine();
		output.write("opt=$STRING");output.newLine();
		output.newLine();
		output.write("name=isomorph");output.newLine();
		output.write("desc=test two finite-state machines for isomorphism");output.newLine();
		output.newLine();
		output.write("name=flexec");output.newLine();
		output.write("desc=test a word for membership in a finite language");output.newLine();
		output.write("opt=$STRING");output.newLine();
		output.newLine();
		output.write("***Tools***");output.newLine();
		output.write("viewer=fmtoview");output.newLine();
		output.write("desc=view an FM");output.newLine();
		output.write("cmd=fmtoview < $INFILE");output.newLine();
		output.newLine();
		output.write("editor=xfig");output.newLine();
		output.write("desc=edit an FM");output.newLine(); 
		output.write("cmd=xfig $INFILE");output.newLine(); 
		output.newLine();
		output.write("fm_to_editor=fmtofig");output.newLine();
		output.write("desc=convert to the editor's file type");output.newLine();
		output.write("cmd=cat $INFILE | fmtofig > $OUTFILE");output.newLine();

	}
	
	// catch any exceptions thown
	catch (Exception e)
	{
		// should use Global error handler, but there are problems implimenting that right now, for debug purposes use
		// System.out
	System.out.println(e);
	}
	// close the output stream.
	finally	
	{
	output.close();
	}
	
		
	}
}